#include <windows.h>
#include <gl/glut.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include "boid.h"
#include "matrix4.h"

#include "timer.h"

//music!!!
#include "fmod.h"

CTimer timer;

std::vector<Boid*> boids;
Boid target;
Vec3 mousep;

bool updown, downdown, leftdown, rightdown;

Vec3 campos;

FSOUND_STREAM* tune;

Wall wall;
Wall insulatedWall;

long tuneTime;
long oldTuneTime = 0;
long oldSTuneTime = 0;
int  tuneInterval = 0;;
int  tuneSInterval = 0;

int two = 0;

void renderScene(void)
{
	
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	//pull the camera back a bit
	//glTranslatef(-campos.x, -campos.y, -40);
	gluLookAt( -20, -20, 40, 
					0, 0, 0,
						0, 0, 1);
	
	if (updown) target.position.y += 0.2;
	if (leftdown) target.position.x -= 0.2;
	if (rightdown) target.position.x += 0.2;
	if (downdown) target.position.y -= 0.2;
/*
	if (updown) campos.y += 0.5;
	if (leftdown) campos.x -= 0.5;
	if (rightdown) campos.x += 0.5;
	if (downdown) campos.y -= 0.5;*/
	
	
	//boid.update();
	//boid.draw();

	timer.stoptimer();
	float timeElapsed = timer.timeintv();
	timer.starttimer();/*
	std::cout << "t: " << timeElapsed << std::endl;
	if (-timeElapsed < 1/60) return;
	else {
		timer.stoptimer();
		timer.starttimer();
	}*/

	for (unsigned i = 0; i < boids.size(); i++)
	{
		boids[i]->update(-timeElapsed);
	}

	for (unsigned i = 0; i < boids.size(); i++)
	{
		boids[i]->draw(two);
	}

	target.draw(1);

	wall.draw();

	// move down slightly and draw a grid!
	tuneTime = FSOUND_Stream_GetTime(tune);
	tuneInterval = tuneTime - oldTuneTime;
	tuneSInterval = tuneTime - oldSTuneTime;
	if (tuneInterval >= 330)
	{
		two = !two;
		oldTuneTime = tuneTime;
	}
	if (tuneSInterval >= 990)
	{
		two = !two;
		oldSTuneTime = tuneTime;
		oldTuneTime = tuneTime;
	}
	//if (two)
	//{
		glColor3f(0.8, 0.8, 1.0);

	/*}
	else
	{
		glColor3f(0.8, 0.1, .1);

	}*/
	
	glTranslatef(0, 0, -0.5);
	glBegin(GL_LINES);
	for (int i = -20; i <= 20; i++)
	{
		glVertex3f(i, -20, 0);
		glVertex3f(i, 20, 0);
		glVertex3f(-20, i, 0);
		glVertex3f(20, i, 0);
	}
	glEnd();


	glutSwapBuffers();

	
}

void initGL(void)
{
	glClearColor(1, 1, 1, 1);
	glColor3f(0, 0, 0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(45, 1, 0.1, 100);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

}

void mouseHandler(int button, int state, int x, int y)
{
	/*
	boid.heading += Vec3(0, -0.1, 0);
	std::cout << "BH!!!!: " << boid.heading << "\n\n";
	boid.updateBasisFromHeading();

	renderScene();*/
}

void pMouse(int x, int y)
{
	/*
	double m[16], p[16];
	int v[4];
	glGetDoublev(GL_MODELVIEW_MATRIX, m);
	glGetDoublev(GL_PROJECTION_MATRIX, p);
	glGetIntegerv(GL_VIEWPORT, v);
	
	GLdouble sx, sy, sz, ex, ey, ez;

	gluUnProject(x, 600-y, 0.1, m, p, v, &sx, &sy, &sz);
	gluUnProject(x, 600-y, 1000, m, p, v, &ex, &ey, &ez);

	float u = sz / sz - ez;

	

	Vec3 s(sx, sy, sz);
	Vec3 e(ex, ey, ez);

	mousep = s*(1-u) + e*u;
	//mousep.z = 0;

	renderScene();*/
}

void keyUp(int key, int x, int y) {
	switch (key)
	{
	case GLUT_KEY_LEFT:
		leftdown = false;
		break;
	case GLUT_KEY_RIGHT:
		rightdown = false;
		break;
	case GLUT_KEY_DOWN:
		downdown = false;
		break;
	case GLUT_KEY_UP:
		updown = false;
		break;

	}
}

void keyDown(int key, int x, int y) {
	switch (key)
	{
	case GLUT_KEY_LEFT:
		leftdown = true;
		break;
	case GLUT_KEY_RIGHT:
		rightdown = true;
		break;
	case GLUT_KEY_DOWN:
		downdown = true;
		break;
	case GLUT_KEY_UP:
		updown = true;
		break;

	}
}


int main (int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitWindowPosition(100, 100);
	glutInitWindowSize(600, 600);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("Steering");
	glutDisplayFunc(renderScene);
	//glutMouseFunc(mouseHandler);
	//glutPassiveMotionFunc(pMouse);
	glutIdleFunc(renderScene);
	glutSpecialFunc(keyDown);
	glutSpecialUpFunc(keyUp);
	
	freopen("log.txt", "w", stdout);

	Vec3 h(1, 1, 0);
	h.normalize();

	//Init FMOD!
	
	FSOUND_Init(44100, 32, 0);
	/*
	FSOUND_SAMPLE* tune = FSOUND_Sample_Load(FSOUND_FREE, "the9.wav", FSOUND_STEREO|FSOUND_LOOP_OFF, 0);
	FSOUND_PlaySound(FSOUND_FREE, tune);
	*/
	tune = FSOUND_Stream_OpenFile("the9.wav", FSOUND_2D, 0);
	FSOUND_Stream_Play(FSOUND_FREE, tune);


	

	//boid = Boid(Vec3(0, 0.5, 0), h, Vec3(0, 0, 1));
	target = Boid(Vec3(10, 10, 0), Vec3(0, 1, 0), Vec3(0, 0, 1));
	target.colour = Colour(1, 0, 0);

	for (int i = 0; i < 40; i++ )
	{
		boids.push_back(new Boid(Vec3(Random(-10, 10),Random(-10, 10), 0), Vec3(0, 1, 0),  Vec3(0, 0, 1)));
		//boids.push_back(new Boid(Vec3(0, 1, 0), Vec3(0, 1, 0),  Vec3(0, 0, 1)));
		//boids[i]->addBehaviour(new BWander(boids[i], Vec3(0, 0, 2), 0.5, 1));
		boids[i]->addBehaviour(new BArrive(boids[i], &target, 0.5));
		boids[i]->addBehaviour(new BSeperation((std::vector<B*>*)&boids, boids[i], 0.1));
		
		boids[i]->avoidWalls = new BAvoidWalls(&insulatedWall, 2, boids[i], 1);
		boids[i]->avoidBoids = new BUCA((std::vector<B*>*)&boids, boids[i], 1);

	}
	
	// This is the wall we'll draw
	wall.addSegment(Vec3(-15, -15, 0), Vec3(15, -15, 0), Vec3(0, 1, 0));
	wall.addSegment(Vec3(15, -15, 0), Vec3(15, 15, 0), Vec3(-1, 0, 0));
	wall.addSegment(Vec3(15, 15, 0), Vec3(-15, 15, 0), Vec3(0, -1, 0));
	wall.addSegment(Vec3(-15, 15, 0), Vec3(-15, -15, 0), Vec3(1, 0, 0));
	
	// this is the wall we'll test against, so the boids son't bump into the walls
	insulatedWall.addSegment(Vec3(-14, -14, 0), Vec3(14, -14, 0), Vec3(0, 1, 0));
	insulatedWall.addSegment(Vec3(14, -14, 0), Vec3(14, 14, 0), Vec3(-1, 0, 0));
	insulatedWall.addSegment(Vec3(14, 14, 0), Vec3(-14, 14, 0), Vec3(0, -1, 0));
	insulatedWall.addSegment(Vec3(-14, 14, 0), Vec3(-14, -14, 0), Vec3(1, 0, 0));
	insulatedWall.colour.set(0.95, 0.95, 1);
	

	//boid.addBehaviour(new BWander(&boid, Vec3(0, 0, 2), 1, 1));
	//boid.addBehaviour(new BOffsetArrive(&boid, &target, Vec3(0, 0, -2), 1));

	updown = downdown = leftdown = rightdown = false;

	initGL();
	
	timer.starttimer();

	glutMainLoop();
}