#include <windows.h>
#include <gl/glut.h>
#include <gl/gl.h>
#include <gl/glu.h>

#include "matrix4.h"

#include "timer.h"

#include "cell.h"

#include <iostream>



CTimer timer;

Vec3 mousep;

bool updown, downdown, leftdown, rightdown, running;

Vec3 campos;

int wWidth = 600;
int wHeight = 600;

CA cellAuto(60, 10);

float simTime = 0;

float speed = 20;

void renderScene(void)
{
	
    // update camera position
	//if (updown) campos.y +=1;
	//if (downdown) campos.y -=1;
	//if (leftdown) campos.x -=1;
	//if (rightdown) campos.x +=1;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	glTranslatef(-campos.x, -campos.y, 0);

	
	
	timer.stoptimer();
	float timeElapsed = timer.timeintv();
	timer.starttimer();

	simTime += timeElapsed;

	if (simTime > 1/speed && cellAuto.running)
	{
		cellAuto.update();
		simTime = 0;
	}

	//std::cout << timeElapsed << std::endl;


	cellAuto.draw();
	


	glutSwapBuffers();


}

void initGL(void)
{
	glClearColor(1, 1, 1, 1);
	glColor3f(0, 0, 0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//gluPerspective(45, 1, 0.1, 100);
	gluOrtho2D(0, 600, 0, 600);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

}

void mouseHandler(int button, int state, int x, int y)
{
	if (state == GLUT_UP)
	{
		cellAuto.touchCell(x, wHeight - y);
	}
}

void pMouse(int x, int y)
{
	/*
	double m[16], p[16];
	int v[4];
	glGetDoublev(GL_MODELVIEW_MATRIX, m);
	glGetDoublev(GL_PROJECTION_MATRIX, p);
	glGetIntegerv(GL_VIEWPORT, v);

	GLdouble sx, sy, sz, ex, ey, ez;

	gluUnProject(x, 600-y, 0.1, m, p, v, &sx, &sy, &sz);
	gluUnProject(x, 600-y, 1000, m, p, v, &ex, &ey, &ez);

	float u = sz / sz - ez;



	Vec3 s(sx, sy, sz);
	Vec3 e(ex, ey, ez);

	mousep = s*(1-u) + e*u;
	//mousep.z = 0;

	renderScene();*/
}

void keyUp(int key, int x, int y) {
	switch (key)
	{
	case GLUT_KEY_LEFT:
		leftdown = false;
		break;
	case GLUT_KEY_RIGHT:
		rightdown = false;
		break;
	case GLUT_KEY_DOWN:
		downdown = false;
		break;
	case GLUT_KEY_UP:
		updown = false;
		break;
	case GLUT_KEY_F10:
		cellAuto.running = !cellAuto.running;
		break;

	}
}

void keyDown(int key, int x, int y) {
	switch (key)
	{
	case GLUT_KEY_LEFT:
		leftdown = true;
		break;
	case GLUT_KEY_RIGHT:
		rightdown = true;
		break;
	case GLUT_KEY_DOWN:
		downdown = true;
		break;
	case GLUT_KEY_UP:
		updown = true;
		break;

	}
}

void menuFunc(int value)
{
	if (value == -1) cellAuto.clear();
	
	if (value == 10030) speed = 0;
	else speed = 1/(value-10000);
}


int main (int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitWindowPosition(100, 100);
	glutInitWindowSize(wWidth, wHeight);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("alGameOfLife");
	glutDisplayFunc(renderScene);
	glutMouseFunc(mouseHandler);
	//glutPassiveMotionFunc(pMouse);
	glutIdleFunc(renderScene);
	
	glutSpecialFunc(keyDown);
	glutSpecialUpFunc(keyUp);

	//freopen("log.txt", "w", stdout);

	updown = downdown = leftdown = rightdown = false;
	//cellAuto.testPattern();

	int mainMenu, speedMenu;

	//speedMenu = glutCreateMenu(menuFunc);
	//glutAddMenuEntry("1", 10001);
	//glutAddMenuEntry("2", 10002);
	//glutAddMenuEntry("5", 10005);
	//glutAddMenuEntry("10", 10010);
	//glutAddMenuEntry("20", 10020);

	//mainMenu = glutCreateMenu(menuFunc);
	//glutAddMenuEntry("Clear", -1);
	//glutAddMenuEntry("Speed...", speedMenu);

	//glutAttachMenu(GLUT_RIGHT_BUTTON);

	initGL();

	timer.starttimer();

	glutMainLoop();
}