// HiResTimer.h - A high resolution timer
// Joel Parris
// 10/22/00
#pragma once
#include <windows.h>


class CTimer
{
	// high resolution timer

protected:
	LARGE_INTEGER timerFrequency;
	LARGE_INTEGER startCount;
	LARGE_INTEGER endCount;

	double tstart;
	double tstop;
	double tfreq;
	double time;
	double fps; 
	int nFrames;
//	CString cstr;

public:
	CTimer(void);
	~CTimer(void);
	void starttimer(void);
	void stoptimer(void);
	double timeintv(void);
	double tcorrection;
	void framespersecond();

};


CTimer::CTimer()
{
	// constructor
	nFrames = 0;
	QueryPerformanceFrequency(&timerFrequency);
	tfreq = (double) timerFrequency.QuadPart;

	// calibration
	starttimer();
	stoptimer();
	tcorrection = (double)(endCount.QuadPart - startCount.QuadPart);

}


CTimer::~CTimer()
{
	// destructor
}


void CTimer::starttimer(void)
{
	time = 0.0;
	QueryPerformanceCounter(&startCount);
	tstart = (double)startCount.QuadPart;
}

void CTimer::stoptimer(void)
{
	QueryPerformanceCounter(&endCount);
	tstop = (double)endCount.QuadPart;
}

double CTimer::timeintv(void)
{
	return (tstop - tstart - tcorrection)/(tfreq);
}

void CTimer::framespersecond(void)
{
	nFrames++;
	if (1)
	{
		stoptimer();
		time = timeintv();
		fps = ((double) nFrames)/time;
		//cstr.Format("fps = %f", fps);
		//SetWindowText((GetActiveWindow()), cstr);
		std::cout << "FPS: " << fps << "\n";
		nFrames = 0;
		starttimer();
	}


}
