#pragma once

#include <windows.h>
#include <gl/glut.h>
#include "vector3.h"
#include "colour.h"
#include <vector>
#include <list>

#define  UBOUND 600

using namespace std;

struct GradFieldCell
{
	Vec3 top, bottom, left, right, av;
};


class PP
{
public:
	PP(){
		alive = 1;
	}
	PP(float _mass, float _wetness, Vec3 _position, Vec3 _velocity, colCMY _colour)
	{
		mass		= _mass;
		wetness		= _wetness;
		position	= _position;
		velocity	= _velocity;
		colour		= _colour;
		alive = 1;
		killedThisStep = 0;
		
	}
	PP(const PP& p)
	{
		mass		= p.mass;
		wetness		= p.wetness;
		position	= p.position;
		velocity	= p.velocity;
		colour		= p.colour;
		alive = p.alive;
		killedThisStep = p.killedThisStep;
		lastFramePos = p.lastFramePos;
	}
	~PP(){}

	inline void  operator = (const PP& p)
	{
		mass		= p.mass;
		wetness		= p.wetness;
		position	= p.position;
		velocity	= p.velocity;
		colour		= p.colour;
		alive = p.alive;
		killedThisStep = p.killedThisStep;
		lastFramePos = p.lastFramePos;
	}

	float	mass;
	float	wetness;
	Vec3	velocity;
	Vec3	position;
	Vec3	lastFramePos;

	colCMY	colour;

	int alive;
	int killedThisStep;

	void drawParticle(float size);
	

};


class PPSystem
{
public:
	PPSystem(float _cEvap, Vec3 _cGrav, float _cFric){
		cEvap = _cEvap;
		cGrav = _cGrav;
		cFric = _cFric;
		
	}
	~PPSystem(){}

	
	unsigned numParticles();
	void kill(int idx);
	void reincarnate(float _mass, float _wetness, Vec3 _position, Vec3 _velocity, colCMY _colour);
	void addParticle(float _mass, float _wetness, Vec3 _position, Vec3 _velocity, colCMY _colour);
	void drawParticles(float size);
	void draw(float* colArray, float dt, float* w);
	void drawP();
	void update(float dt, GradFieldCell* gf, float* w, float* colArr);

	vector<PP>	particleArray;
	list<int>	deadList;

	// constants
	float cEvap;
	Vec3 cGrav;
	float cFric;
};